<?php
namespace Avaliacao\Entities;

use Geral\Util\DateUtil;
use Geral\Util\NovoCodigo;
use Setforms2\Shared\Registry;

class Combquestaval extends Base\Combquestaval
{
    public function insereCombQuestAval(
        $nrorg,
        $nravaliacao,
        $nome_combinacao,
        $id_dafault
    ){
        try{
            $obj = new self();

            $obj->setNrcombquestaval(NovoCodigo::geraCodigo($nrorg, 'COMBQUESTAVAL',1,10,true));
            $obj->setNravaliacao($nravaliacao);
            $obj->setNmcombquestaval($nome_combinacao);
            $obj->setDtinclusao(DateUtil::getDataAtual());
            $obj->setDtultatu(DateUtil::getDataAtual());
            $obj->setIddefault($id_dafault);
            $obj->setIdativo('S');
            $obj->setNrorg($nrorg);
            $obj->setNrorginclusao($nrorg);
            $obj->setNrorgultatu($nrorg);

            $obj->persist();

            Registry::getEntityManager()->flush();

            return $obj;

        } catch (\Exception $e) {
            tk_warning($e->getMessage());
        }

        return $obj;

    }

    public static function retornaCombinacaoPadrao($nrorg, $nravaliacao) {
        $obj = self::getObjectByWhere(
            "NRORG = ? AND NRAVALIACAO = ? AND IDDEFAULT = 'S'",
            array(
                $nrorg,
                $nravaliacao,
            )
        );
        return $obj;
    }
    
    public static function busca_Combquestaval($nrorg) {
        $obj = self::getObjectByWhere(
            "NRORG = ? AND NMCOMBQUESTAVAL = 'PADRÃO' AND IDDEFAULT = 'S'",
            array(
                $nrorg,
            )
        );
        return $obj;
    }    

    public static function excluiCombinacoesQuestao($nrorg, $nravaliacao) {
        try {
            $sql = "DELETE FROM COMBQUESTAVAL
                     WHERE NRORG = {$nrorg}
                       AND NRAVALIACAO = {$nravaliacao}";
            \Setforms2\Shared\Connection::getInstance()->execute($sql);
            return true;
        } catch(\Exception $e) {
            return false;
        }
    }


    public function retornaCombinacoesAvaliacao ($nrorg, $nravaliacao) {
        $objs = self::getObjectsByWhere(
            'NRORG = ? AND NRAVALIACAO = ?',
            array(
                $nrorg,
                $nravaliacao,
            )
        );
        return $objs;
    }
}