<?php
namespace Financeiro\Logic\ContasPagar;

use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;

class ContasPrevistaAF
{


    /**
     * Executa procedure EXCLUI_CONTAPAGAR_PREVISTA
     *
     * @param $nrorg
     * @param $cdfildest
     * @param $cdfillanc
     * @param $nrautoforn
     * @throws \Exception
     */
    public static function executaExcluiContasPagarPrevista($nrorg, $cdfildest, $cdfillanc, $nrautoforn) {
        try {
            $procedure = new Procedure("EXCLUI_CONTAPAGAR_PREVISTA");
            self::addParametrosExcluiContasPagarPrevista($procedure, $nrorg, $cdfildest, $cdfillanc, $nrautoforn);
            $procedure->call();
        } catch (\Exception $e) {
            throw $e;
        }
    }


    /**
     * Adiciona os parametros da procedure EXCLUI_CONTAPAGAR_PREVISTA.
     *
     * @param \Setforms2\Runtime\Helper\Procedure $procedure
     * @param $nrorg
     * @param $cdfildest
     * @param $cdfillanc
     * @param $nrautoforn
     */
    protected static function addParametrosExcluiContasPagarPrevista(
        Procedure $procedure, $nrorg, $cdfildest, $cdfillanc, $nrautoforn)
    {
//        $procedure->addParam(
//            new Param(
//                'P_NRORG',
//                Param::PARAM_INPUT,
//                $nrorg,
//                Param::PARAM_TYPE_INT
//            )
//        );
        $procedure->addParam(
            new Param(
                'P_CDFILDEST',
                Param::PARAM_INPUT,
                $cdfildest,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDFILLANC',
                Param::PARAM_INPUT,
                $cdfillanc,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_NRAUTOFORN',
                Param::PARAM_INPUT,
                $nrautoforn,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_RESULTADO',
                Param::PARAM_OUTPUT,
                'CNT_SUP_VRORC',
                Param::PARAM_TYPE_STR,
                13
            )
        );
    }


    /**
     * Executa procedure GERA_CONTAPAGAR_PREVISTA
     *
     * @param $nrorg
     * @param $cdfildest
     * @param $cdfillanc
     * @param $nrautoforn
     * @throws \Exception
     */
    public static function executaGeraContasPagarPrevista($nrorg, $cdfildest, $cdfillanc, $nrautoforn) {
        try {
            $procedure = new Procedure("GERA_CONTAPAGAR_PREVISTA");
            self::addParametrosGeraContasPagarPrevista($procedure, $nrorg, $cdfildest, $cdfillanc, $nrautoforn);
            $procedure->call();
        } catch (\Exception $e) {
            throw $e;
        }
    }


    /**
     * Adiciona os parametros da procedure GERA_CONTAPAGAR_PREVISTA.
     *
     * @param \Setforms2\Runtime\Helper\Procedure $procedure
     * @param $nrorg
     * @param $cdfildest
     * @param $cdfillanc
     * @param $nrautoforn
     */
    protected static function addParametrosGeraContasPagarPrevista(
        Procedure $procedure, $nrorg, $cdfildest, $cdfillanc, $nrautoforn)
    {
//        $procedure->addParam(
//            new Param(
//                'P_NRORG',
//                Param::PARAM_INPUT,
//                $nrorg,
//                Param::PARAM_TYPE_INT
//            )
//        );
        $procedure->addParam(
            new Param(
                'P_CDFILDEST',
                Param::PARAM_INPUT,
                $cdfildest,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_CDFILLANC',
                Param::PARAM_INPUT,
                $cdfillanc,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param(
                'P_NRAUTOFORN',
                Param::PARAM_INPUT,
                $nrautoforn,
                Param::PARAM_TYPE_STR
            )
        );

    }



}
