/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CCTB                                                     */
/* Tabela : CONTCTBL                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/07/2001 - Newton Neves dos Santos                                       */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CCTB
BEFORE INSERT OR UPDATE OR DELETE
ON CONTCTBL FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCCTB := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDCONTCTBL,0)   <> NVL(:NEW.CDCONTCTBL,0))   OR
         (NVL(:OLD.NMCONTCTBL,0)   <> NVL(:NEW.NMCONTCTBL,0))   OR
         (NVL(:OLD.CDNVCONTCTBL,0) <> NVL(:NEW.CDNVCONTCTBL,0)) OR
         (NVL(:OLD.IDTIPOCONT,0)   <> NVL(:NEW.IDTIPOCONT,0))   OR
         (NVL(:OLD.CDRATEIO,0)     <> NVL(:NEW.CDRATEIO,0))     OR
         (NVL(:OLD.CDCONTREDU,0)   <> NVL(:NEW.CDCONTREDU,0))   OR
         (NVL(:OLD.CDCONTANTE,0)   <> NVL(:NEW.CDCONTANTE,0))   OR
         (NVL(:OLD.IDTIPOPESS,0)   <> NVL(:NEW.IDTIPOPESS,0))   OR
         (NVL(:OLD.IDCONTCCUS,0)   <> NVL(:NEW.IDCONTCCUS,0))   OR
         (NVL(:OLD.IDTIPOCOME,0)   <> NVL(:NEW.IDTIPOCOME,0)) THEN
         :NEW.DTULTATUCCTB := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CONTCTBL', '', 'CDNVCONTCTBL='||:OLD.CDNVCONTCTBL||';CDCONTCTBL='||:OLD.CDCONTCTBL||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE CONTCTBL MODIFY DTULTATUCCTB DEFAULT SYSDATE
/
