<?php
namespace Teknisa\Model\Financeiro\Repositories;


class Contareceber extends \Doctrine\ORM\EntityRepository {
    
    public function findBilletIssued($filterQuery,$cdcliente){
        $query = <<<SQL
        SELECT DSCONTAREC,CDCLIENTE ,CDFILIAL, NRLANCTONF,NRSEQVENREC, NRORG, NRNOTAFISC,EXPIRED,NRLANBOLREC,CDREDUCONT,
                        NRPARCELAREC,TO_CHAR(DTEMISSAO, 'DD/MM/YYYY') as DTEMISSAO, TO_CHAR(DTATUAVENREC, 'DD/MM/YYYY') as DTATUAVENREC, DTORIGVENREC,
                        TO_CHAR(DTBAIXAREC, 'DD/MM/YYYY') AS DTBAIXAREC, VRATUAREC, IDSTATREC, VRFINALBREC, SDABERTO
          FROM (SELECT C.DSCONTAREC,CLI.CDCLIENTE , C.CDFILIAL, C.NRLANCTONF,C.NRSEQVENREC, C.NRORG, N.NRNOTAFISC,
                        C.NRPARCELAREC, N.DTEMISSAO, C.DTATUAVENREC, C.DTORIGVENREC, BX.DTBAIXAREC, C.VRATUAREC, DECODE(C.IDSTATREC,'A','N','Y') AS IDSTATREC,
                        BO.VRFINALBREC, DECODE(C.IDSTATREC,'A',C.VRATUAREC,0) AS SDABERTO,BO.NRLANBOLREC,BO.CDREDUCONT,
                        CASE WHEN SYSDATE > C.DTATUAVENREC THEN 'Y'
                             ELSE 'N'
                        END AS EXPIRED,
                         TO_CHAR(DTATUAVENREC, 'YYYYMMDD')||TO_CHAR(DTEMISSAO, 'YYYYMMDD') AS ORDERBY
                  FROM CONTARECEBER C
                  JOIN NOTAFISCAL N ON (N.NRLANCTONF = C.NRLANCTONF AND N.CDFILIAL = C.CDFILIAL AND N.NRORG = C.NRORG )
                  JOIN CLIENTE CLI ON (N.CDCLIENTE = CLI.CDCLIENTE AND N.NRORG = CLI.NRORG)
                  JOIN BOLETRECEBER BO ON (BO.NRLANBOLREC = C.NRLANBOLREC AND BO.CDFILIAL = C.CDFILIAL)
             LEFT JOIN BAIXARECEBIDA BX ON (BO.CDFILIAL= BX.CDFILIAL AND BO.NRBAIXAREC = BX.NRBAIXAREC))
         WHERE 1 = 1
         AND CDCLIENTE = :CDCLIENTE
               $filterQuery
       ORDER BY ORDERBY DESC,
            NRNOTAFISC DESC, NRPARCELAREC ASC
SQL;

        $params = array(
            'CDCLIENTE' => $cdcliente
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query,$params);
    }

    public function findBilletDetails($nrlanctonf,$cdfilial){
        $query = <<<SQL
         SELECT * FROM(
                SELECT ITM.DSPRODEMIS AS DESCRIPTION ,' Serviços' AS TYPE_ITEM ,
                       (
                            ROUND(ITM.VRCONTITEM,2)
                           -NVL(( SELECT SUM(ROUND(VRIMPOSTONF,2))
                                    FROM IMPOSTONF INF JOIN IMPOSTO IMS ON (IMS.CDIMPOSTO = INF.CDIMPOSTO)
                                   WHERE NRLANCTONF = :NRLANCTONF
                                     AND CDFILIAL = :CDFILIAL
                                     AND IDTRATIMPO = 'R'),0)
                           +NVL( (SELECT SUM(ROUND(VRAJBOLREC,2))
                                    FROM AJBOLREC AJB
                                    JOIN CONTARECEBER CON ON (AJB.NRLANBOLREC = CON.NRLANBOLREC AND AJB.CDFILIAL = CON.CDFILIAL)
                                   WHERE CON.NRLANCTONF = :NRLANCTONF AND CON.CDFILIAL = :CDFILIAL),0)
                       ) AS VALUE_ITEM,(SELECT DISTINCT 'Y' FROM FCT_APURACAO FCA
                                                 JOIN FCT_VENCPREVCONT FVE ON (FVE.NRAPURACAO = FCA.NRAPURACAO)
                                                 JOIN FCT_CONTRATO FCO ON (FCO.NRSEQCONTRATO = FVE.NRSEQCONTRATO)
                                                 JOIN FCT_ITEMCONTRATO FIT ON (FIT.NRSEQCONTRATO = FVE.NRSEQCONTRATO)
                                                 JOIN FCT_TIPOMEDIDASERV FTI ON (FTI.CDTPMEDIDASERV = FIT.CDTPMEDIDASERV)
                                                WHERE FCA.NRLANCTONF = :NRLANCTONF
                                                  AND CDFILIAL = :CDFILIAL
                                                  AND VRTOTITEMCONT > 0) AS IS_DETAIL

                FROM  ITEMPRODUTO ITM
                WHERE ITM.NRLANCTONF = :NRLANCTONF AND ITM.CDFILIAL = :CDFILIAL
                UNION
                SELECT DSAJUCTREC AS DESCRIPTION ,'Ajustes' AS TYPE_ITEM ,ROUND(VRAJUSTEREC,2) AS VALUE_ITEM, '' AS IS_DETAIL  FROM AJCTRECEBER AJC
                JOIN TIPOAJRECEBER TIA ON (TIA.CDAJUCTREC = AJC.CDAJUCTREC)
                WHERE NRLANCTONF = :NRLANCTONF AND CDFILIAL = :CDFILIAL
            )
            ORDER BY VALUE_ITEM DESC
SQL;

        $params = array(
            'NRLANCTONF' => $nrlanctonf,
            'CDFILIAL' => $cdfilial,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query,$params);
    }

    public function findProductDetails($nrlanctonf,$cdfilial){
        $query = <<<SQL
       SELECT FIT.NMITEMCONTRATO AS DESCRIPTION,' Produtos' AS TYPE_ITEM ,
              ROUND(ITV.VRTOTITEMCONT,2) AS VALUE_ITEM,
              TO_CHAR(ROUND(
                  (ITV.VRUNITITEMCONT)
                  +(ITV.VRTOTITEMCONT-(ITV.VRUNITITEMCONT*(ITV.QTMEDIDACONTR*ITV.QTITEMCONTRATO)))/(ITV.QTMEDIDACONTR*ITV.QTITEMCONTRATO)
              ,2)) AS VALUE_UNITY,
              TO_CHAR(ITV.QTMEDIDACONTR*ITV.QTITEMCONTRATO) AS QUANTITY, DSTPMEDIDASERV AS UNITY
         FROM FCT_APURACAO FCA
         JOIN FCT_VENCPREVCONT FVE ON (FVE.NRAPURACAO = FCA.NRAPURACAO)
         JOIN FCT_ITVENCPREVCONT ITV ON (FVE.NRVENCPREVCONT = ITV.NRVENCPREVCONT)
         JOIN FCT_CONTRATO FCO ON (FCO.NRSEQCONTRATO = FVE.NRSEQCONTRATO)
         JOIN FCT_ITEMCONTRATO FIT ON (FIT.NRSEQCONTRATO = FVE.NRSEQCONTRATO AND FIT.NRITEMOCONTRATO = ITV.NRITEMOCONTRATO)
         JOIN FCT_TIPOMEDIDASERV FTI ON (FTI.CDTPMEDIDASERV = FIT.CDTPMEDIDASERV)
        WHERE FCA.NRLANCTONF = :NRLANCTONF
          AND FCA.CDFILIAL = :CDFILIAL
          AND FIT.VRTOTITEMCONT > 0
              UNION
       SELECT IMS.NMIMPOSTO AS DESCRIPTION ,'Ajustes' AS TYPE_ITEM ,-ROUND(INF.VRIMPOSTONF,2) AS VALUE_ITEM , '' AS QUANTITY, '' AS VALUE_UNITY, '' AS UNITY
        FROM IMPOSTONF INF JOIN IMPOSTO IMS ON (IMS.CDIMPOSTO = INF.CDIMPOSTO)
        JOIN IMPOSTO IMS ON (IMS.CDIMPOSTO = INF.CDIMPOSTO)
       WHERE INF.NRLANCTONF = :NRLANCTONF
         AND INF.CDFILIAL = :CDFILIAL
         AND IMS.IDTRATIMPO = 'R'
         AND INF.VRIMPOSTONF > 0
             UNION
      SELECT TIA.DSAJUCTREC AS DESCRIPTION ,'Ajustes +' AS TYPE_ITEM, +ROUND(AJB.VRAJBOLREC,2) AS VALUE_ITEM , '' AS QUANTITY, '' AS VALUE_UNITY, '' AS UNITY
        FROM AJBOLREC AJB
        JOIN TIPOAJRECEBER TIA ON (TIA.CDAJUCTREC = AJB.CDAJUCTREC)
        JOIN CONTARECEBER CON ON (AJB.NRLANBOLREC = CON.NRLANBOLREC AND AJB.CDFILIAL = CON.CDFILIAL)
       WHERE CON.NRLANCTONF = :NRLANCTONF AND CON.CDFILIAL = :CDFILIAL
SQL;

        $params = array(
            'NRLANCTONF' => $nrlanctonf,
            'CDFILIAL' => $cdfilial,
        );
        return $this->getEntityManager()->getConnection()->fetchAll($query,$params);
    }

    
}